#include <stdio.h>
#include <stdlib.h>
#include <sys/time.h>

void kernel_cpu(float *B0,float *B1,float *B2,float *B3,float *B4,int N){
for(int i=0;i<N;i++){
B0[i] = B4[i];
B1[i] = B4[i]*B4[i]+B4[i]/B4[i];
B2[i] = B4[i]-B4[i];
B3[i] = B4[i]-B4[i];
}
}

int main(int argc,char **argv) {
int size=460418;
int intBytes = size*sizeof(int);
int floatBytes = size*sizeof(float);
float *B0;
B0 = (float *)malloc(floatBytes);
float *B1;
B1 = (float *)malloc(floatBytes);
float *B2;
B2 = (float *)malloc(floatBytes);
float *B3;
B3 = (float *)malloc(floatBytes);
float *B4;
B4 = (float *)malloc(floatBytes);
for(int i=0;i<460418;i++){
B0[i] = 12.9430492871+i+1;
B1[i] = 12.6865701834+i+1;
B2[i] = 93.1964822459*i+1;
B3[i] = 49.3970496402+i+1;
B4[i] = 68.8667550367+i+1;
}
struct timeval time0,time1;
gettimeofday(&time0,NULL);
FILE *file_for_block_of_interest = fopen("./profile_in_block.txt","w");
if(file_for_block_of_interest) {
char Buf[2] = "1";
fwrite(Buf, 1, 1, file_for_block_of_interest);
fclose(file_for_block_of_interest);}
kernel_cpu(B0,B1,B2,B3,B4,460418);
file_for_block_of_interest = fopen("./profile_in_block.txt","w");
if(file_for_block_of_interest) {
char Buf[2] = "0";
fwrite(Buf, 1, 1, file_for_block_of_interest);
fclose(file_for_block_of_interest);}
gettimeofday(&time1,NULL);
double totaltime10 = (time1.tv_sec*1000000.0 + time1.tv_usec) - (time0.tv_sec*1000000.0 + time0.tv_usec);
fprintf(stderr, "CPU time: %lf msecs ",  (totaltime10)/1000.0F); 
free(B0);
free(B1);
free(B2);
free(B3);
free(B4);
printf("\n");return 0; }