#include <iostream>
#include <cuda.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/time.h>
using namespace std;

__global__ void kernel_gpu(int *A0,int *A1,int *A2,int *A3,int *A4,int *A5,int *A6,int *A7,int *A8,float *B0,float *B1,float *B2,float *B3,float *B4,float *B5,float *B6,int N){
int i = blockIdx.x * blockDim.x + threadIdx.x;
if (i < N){
A0[i] = A8[i];
A1[i] = A7[i];
A2[i] = A6[i]*A6[i]/A7[i]-A7[i];
A3[i] = A7[i]+A6[i]/A7[i]+A6[i];
A4[i] = A8[i]*A6[i]+A8[i];
A5[i] = A8[i];
B0[i] = B5[i]+B6[i]-B4[i]*B4[i];
B1[i] = B6[i];
B2[i] = B5[i];
B3[i] = B5[i];
}
}

void kernel_cpu(int *A0,int *A1,int *A2,int *A3,int *A4,int *A5,int *A6,int *A7,int *A8,float *B0,float *B1,float *B2,float *B3,float *B4,float *B5,float *B6,int N){
for(int i=0;i<N;i++){
A0[i] = A8[i];
A1[i] = A7[i];
A2[i] = A6[i]*A6[i]/A7[i]-A7[i];
A3[i] = A7[i]+A6[i]/A7[i]+A6[i];
A4[i] = A8[i]*A6[i]+A8[i];
A5[i] = A8[i];
B0[i] = B5[i]+B6[i]-B4[i]*B4[i];
B1[i] = B6[i];
B2[i] = B5[i];
B3[i] = B5[i];
}
}

int main(int argc,char **argv) {
fprintf(stderr, "633 ");
int size=656880;
int intBytes = size*sizeof(int);
int floatBytes = size*sizeof(float);
int *A0;
A0 = (int *)malloc(intBytes);
int *A1;
A1 = (int *)malloc(intBytes);
int *A2;
A2 = (int *)malloc(intBytes);
int *A3;
A3 = (int *)malloc(intBytes);
int *A4;
A4 = (int *)malloc(intBytes);
int *A5;
A5 = (int *)malloc(intBytes);
int *A6;
A6 = (int *)malloc(intBytes);
int *A7;
A7 = (int *)malloc(intBytes);
int *A8;
A8 = (int *)malloc(intBytes);
float *B0;
B0 = (float *)malloc(floatBytes);
float *B1;
B1 = (float *)malloc(floatBytes);
float *B2;
B2 = (float *)malloc(floatBytes);
float *B3;
B3 = (float *)malloc(floatBytes);
float *B4;
B4 = (float *)malloc(floatBytes);
float *B5;
B5 = (float *)malloc(floatBytes);
float *B6;
B6 = (float *)malloc(floatBytes);
for(int i=0;i<656880;i++){
A0[i] = 22*i+1;
A1[i] = 71+i+1;
A2[i] = 26+i+1;
A3[i] = 43+i+1;
A4[i] = 58*i+1;
A5[i] = 1+i+1;
A6[i] = 7*i+1;
A7[i] = 12+i+1;
A8[i] = 42+i+1;
B0[i] = 78.4955904743+i+1;
B1[i] = 8.7818418773*i+1;
B2[i] = 12.4600282859*i+1;
B3[i] = 62.5113773175+i+1;
B4[i] = 63.307702416*i+1;
B5[i] = 14.0836550216*i+1;
B6[i] = 4.08509685298+i+1;
}
int *d_A0;
cudaMalloc((void **)&d_A0,656880*sizeof(int));
cudaMemcpy(d_A0,A0,656880*sizeof(int),cudaMemcpyHostToDevice);
int *d_A1;
cudaMalloc((void **)&d_A1,656880*sizeof(int));
cudaMemcpy(d_A1,A1,656880*sizeof(int),cudaMemcpyHostToDevice);
int *d_A2;
cudaMalloc((void **)&d_A2,656880*sizeof(int));
cudaMemcpy(d_A2,A2,656880*sizeof(int),cudaMemcpyHostToDevice);
int *d_A3;
cudaMalloc((void **)&d_A3,656880*sizeof(int));
cudaMemcpy(d_A3,A3,656880*sizeof(int),cudaMemcpyHostToDevice);
int *d_A4;
cudaMalloc((void **)&d_A4,656880*sizeof(int));
cudaMemcpy(d_A4,A4,656880*sizeof(int),cudaMemcpyHostToDevice);
int *d_A5;
cudaMalloc((void **)&d_A5,656880*sizeof(int));
cudaMemcpy(d_A5,A5,656880*sizeof(int),cudaMemcpyHostToDevice);
int *d_A6;
cudaMalloc((void **)&d_A6,656880*sizeof(int));
cudaMemcpy(d_A6,A6,656880*sizeof(int),cudaMemcpyHostToDevice);
int *d_A7;
cudaMalloc((void **)&d_A7,656880*sizeof(int));
cudaMemcpy(d_A7,A7,656880*sizeof(int),cudaMemcpyHostToDevice);
int *d_A8;
cudaMalloc((void **)&d_A8,656880*sizeof(int));
cudaMemcpy(d_A8,A8,656880*sizeof(int),cudaMemcpyHostToDevice);
float *d_B0;
cudaMalloc((void **)&d_B0,656880*sizeof(float));
cudaMemcpy(d_B0,B0,656880*sizeof(float),cudaMemcpyHostToDevice);
float *d_B1;
cudaMalloc((void **)&d_B1,656880*sizeof(float));
cudaMemcpy(d_B1,B1,656880*sizeof(float),cudaMemcpyHostToDevice);
float *d_B2;
cudaMalloc((void **)&d_B2,656880*sizeof(float));
cudaMemcpy(d_B2,B2,656880*sizeof(float),cudaMemcpyHostToDevice);
float *d_B3;
cudaMalloc((void **)&d_B3,656880*sizeof(float));
cudaMemcpy(d_B3,B3,656880*sizeof(float),cudaMemcpyHostToDevice);
float *d_B4;
cudaMalloc((void **)&d_B4,656880*sizeof(float));
cudaMemcpy(d_B4,B4,656880*sizeof(float),cudaMemcpyHostToDevice);
float *d_B5;
cudaMalloc((void **)&d_B5,656880*sizeof(float));
cudaMemcpy(d_B5,B5,656880*sizeof(float),cudaMemcpyHostToDevice);
float *d_B6;
cudaMalloc((void **)&d_B6,656880*sizeof(float));
cudaMemcpy(d_B6,B6,656880*sizeof(float),cudaMemcpyHostToDevice);
int n = 2566*256;
int block_size = 256;
int block_no = n/block_size;
struct timeval time0,time1;
gettimeofday(&time0,NULL);
kernel_gpu<<<block_no,block_size>>>(d_A0,d_A1,d_A2,d_A3,d_A4,d_A5,d_A6,d_A7,d_A8,d_B0,d_B1,d_B2,d_B3,d_B4,d_B5,d_B6,656880);
cudaThreadSynchronize();
gettimeofday(&time1,NULL);
double totaltime10 = (time1.tv_sec*1000000.0 + time1.tv_usec) - (time0.tv_sec*1000000.0 + time0.tv_usec);
fprintf(stderr, "GPU time: %lf msecs ",  (totaltime10)/1000.0F);
gettimeofday(&time0,NULL);
kernel_cpu(A0,A1,A2,A3,A4,A5,A6,A7,A8,B0,B1,B2,B3,B4,B5,B6,656880);
gettimeofday(&time1,NULL);
totaltime10 = (time1.tv_sec*1000000.0 + time1.tv_usec) - (time0.tv_sec*1000000.0 + time0.tv_usec);
fprintf(stderr, "CPU time: %lf msecs ",  (totaltime10)/1000.0F);
int *testA0;
testA0 = (int *)malloc(intBytes);
cudaMemcpy(testA0,d_A0,656880*sizeof(int),cudaMemcpyDeviceToHost);
int *testA1;
testA1 = (int *)malloc(intBytes);
cudaMemcpy(testA1,d_A1,656880*sizeof(int),cudaMemcpyDeviceToHost);
int *testA2;
testA2 = (int *)malloc(intBytes);
cudaMemcpy(testA2,d_A2,656880*sizeof(int),cudaMemcpyDeviceToHost);
int *testA3;
testA3 = (int *)malloc(intBytes);
cudaMemcpy(testA3,d_A3,656880*sizeof(int),cudaMemcpyDeviceToHost);
int *testA4;
testA4 = (int *)malloc(intBytes);
cudaMemcpy(testA4,d_A4,656880*sizeof(int),cudaMemcpyDeviceToHost);
int *testA5;
testA5 = (int *)malloc(intBytes);
cudaMemcpy(testA5,d_A5,656880*sizeof(int),cudaMemcpyDeviceToHost);
int *testA6;
testA6 = (int *)malloc(intBytes);
cudaMemcpy(testA6,d_A6,656880*sizeof(int),cudaMemcpyDeviceToHost);
int *testA7;
testA7 = (int *)malloc(intBytes);
cudaMemcpy(testA7,d_A7,656880*sizeof(int),cudaMemcpyDeviceToHost);
int *testA8;
testA8 = (int *)malloc(intBytes);
cudaMemcpy(testA8,d_A8,656880*sizeof(int),cudaMemcpyDeviceToHost);
float *testB0;
testB0 = (float *)malloc(floatBytes);
cudaMemcpy(testB0,d_B0,656880*sizeof(int),cudaMemcpyDeviceToHost);
float *testB1;
testB1 = (float *)malloc(floatBytes);
cudaMemcpy(testB1,d_B1,656880*sizeof(int),cudaMemcpyDeviceToHost);
float *testB2;
testB2 = (float *)malloc(floatBytes);
cudaMemcpy(testB2,d_B2,656880*sizeof(int),cudaMemcpyDeviceToHost);
float *testB3;
testB3 = (float *)malloc(floatBytes);
cudaMemcpy(testB3,d_B3,656880*sizeof(int),cudaMemcpyDeviceToHost);
float *testB4;
testB4 = (float *)malloc(floatBytes);
cudaMemcpy(testB4,d_B4,656880*sizeof(int),cudaMemcpyDeviceToHost);
float *testB5;
testB5 = (float *)malloc(floatBytes);
cudaMemcpy(testB5,d_B5,656880*sizeof(int),cudaMemcpyDeviceToHost);
float *testB6;
testB6 = (float *)malloc(floatBytes);
cudaMemcpy(testB6,d_B6,656880*sizeof(int),cudaMemcpyDeviceToHost);
for(int i=0;i<656880;i++){
if (A0[i] != testA0[i]) {
printf("Invalid kernel ");
break;}
if (A1[i] != testA1[i]) {
printf("Invalid kernel ");
break;}
if (A2[i] != testA2[i]) {
printf("Invalid kernel ");
break;}
if (A3[i] != testA3[i]) {
printf("Invalid kernel ");
break;}
if (A4[i] != testA4[i]) {
printf("Invalid kernel ");
break;}
if (A5[i] != testA5[i]) {
printf("Invalid kernel ");
break;}
if (A6[i] != testA6[i]) {
printf("Invalid kernel ");
break;}
if (A7[i] != testA7[i]) {
printf("Invalid kernel ");
break;}
if (A8[i] != testA8[i]) {
printf("Invalid kernel ");
break;}
}
free(A0);
free(testA0);
cudaFree(d_A0);
free(A1);
free(testA1);
cudaFree(d_A1);
free(A2);
free(testA2);
cudaFree(d_A2);
free(A3);
free(testA3);
cudaFree(d_A3);
free(A4);
free(testA4);
cudaFree(d_A4);
free(A5);
free(testA5);
cudaFree(d_A5);
free(A6);
free(testA6);
cudaFree(d_A6);
free(A7);
free(testA7);
cudaFree(d_A7);
free(A8);
free(testA8);
cudaFree(d_A8);
free(B0);
free(testB0);
cudaFree(d_B0);
free(B1);
free(testB1);
cudaFree(d_B1);
free(B2);
free(testB2);
cudaFree(d_B2);
free(B3);
free(testB3);
cudaFree(d_B3);
free(B4);
free(testB4);
cudaFree(d_B4);
free(B5);
free(testB5);
cudaFree(d_B5);
free(B6);
free(testB6);
cudaFree(d_B6);
printf("\n");return 0; }