#include <stdio.h>
#include <stdlib.h>
#include <sys/time.h>

void kernel_cpu(int *A0,int *A1,int *A2,int *A3,int *A4,int *A5,float *B0,float *B1,float *B2,float *B3,float *B4,int N){
for(int i=0;i<N;i++){
A0[i] = A5[i]/A5[i]+A5[i]+A5[i];
A1[i] = A5[i]*A5[i];
A2[i] = A5[i]/A5[i]-A5[i];
A3[i] = A5[i]+A5[i];
A4[i] = A5[i]/A5[i]/A5[i]-A5[i];
B0[i] = B4[i]/B3[i]+B3[i]/B4[i];
B1[i] = B4[i]-B4[i]/B4[i];
B2[i] = B3[i]*B3[i]/B3[i]/B3[i];
}
}

int main(int argc,char **argv) {
int size=290481;
int intBytes = size*sizeof(int);
int floatBytes = size*sizeof(float);
int *A0;
A0 = (int *)malloc(intBytes);
int *A1;
A1 = (int *)malloc(intBytes);
int *A2;
A2 = (int *)malloc(intBytes);
int *A3;
A3 = (int *)malloc(intBytes);
int *A4;
A4 = (int *)malloc(intBytes);
int *A5;
A5 = (int *)malloc(intBytes);
float *B0;
B0 = (float *)malloc(floatBytes);
float *B1;
B1 = (float *)malloc(floatBytes);
float *B2;
B2 = (float *)malloc(floatBytes);
float *B3;
B3 = (float *)malloc(floatBytes);
float *B4;
B4 = (float *)malloc(floatBytes);
for(int i=0;i<290481;i++){
A0[i] = 50*i+1;
A1[i] = 32+i+1;
A2[i] = 37+i+1;
A3[i] = 42*i+1;
A4[i] = 61+i+1;
A5[i] = 74*i+1;
B0[i] = 13.129045018*i+1;
B1[i] = 53.6983073099*i+1;
B2[i] = 43.0516175547*i+1;
B3[i] = 5.23122061256+i+1;
B4[i] = 29.6278777083*i+1;
}
struct timeval time0,time1;
gettimeofday(&time0,NULL);
FILE *file_for_block_of_interest = fopen("./profile_in_block.txt","w");
if(file_for_block_of_interest) {
char Buf[2] = "1";
fwrite(Buf, 1, 1, file_for_block_of_interest);
fclose(file_for_block_of_interest);}
kernel_cpu(A0,A1,A2,A3,A4,A5,B0,B1,B2,B3,B4,290481);
file_for_block_of_interest = fopen("./profile_in_block.txt","w");
if(file_for_block_of_interest) {
char Buf[2] = "0";
fwrite(Buf, 1, 1, file_for_block_of_interest);
fclose(file_for_block_of_interest);}
gettimeofday(&time1,NULL);
double totaltime10 = (time1.tv_sec*1000000.0 + time1.tv_usec) - (time0.tv_sec*1000000.0 + time0.tv_usec);
fprintf(stderr, "CPU time: %lf msecs ",  (totaltime10)/1000.0F); 
free(A0);
free(A1);
free(A2);
free(A3);
free(A4);
free(A5);
free(B0);
free(B1);
free(B2);
free(B3);
free(B4);
printf("\n");return 0; }