#include <stdio.h>
#include <stdlib.h>
#include <sys/time.h>

void kernel_cpu(int *A0,int *A1,int *A2,int *A3,int *A4,float *B0,float *B1,float *B2,float *B3,float *B4,float *B5,float *B6,int N){
for(int i=0;i<N;i++){
A0[i] = A4[i]*A4[i]-A4[i]*A4[i];
A1[i] = A4[i]-A4[i];
A2[i] = A4[i]-A4[i]+A4[i]-A4[i];
A3[i] = A4[i]*A4[i]+A4[i]+A4[i];
B0[i] = B4[i]*B6[i];
B1[i] = B4[i]/B5[i]+B6[i];
B2[i] = B5[i]/B4[i];
B3[i] = B6[i]/B4[i]+B4[i]*B4[i];
}
}

int main(int argc,char **argv) {
int size=971966;
int intBytes = size*sizeof(int);
int floatBytes = size*sizeof(float);
int *A0;
A0 = (int *)malloc(intBytes);
int *A1;
A1 = (int *)malloc(intBytes);
int *A2;
A2 = (int *)malloc(intBytes);
int *A3;
A3 = (int *)malloc(intBytes);
int *A4;
A4 = (int *)malloc(intBytes);
float *B0;
B0 = (float *)malloc(floatBytes);
float *B1;
B1 = (float *)malloc(floatBytes);
float *B2;
B2 = (float *)malloc(floatBytes);
float *B3;
B3 = (float *)malloc(floatBytes);
float *B4;
B4 = (float *)malloc(floatBytes);
float *B5;
B5 = (float *)malloc(floatBytes);
float *B6;
B6 = (float *)malloc(floatBytes);
for(int i=0;i<971966;i++){
A0[i] = 9+i+1;
A1[i] = 60+i+1;
A2[i] = 32*i+1;
A3[i] = 52*i+1;
A4[i] = 51*i+1;
B0[i] = 58.166832267+i+1;
B1[i] = 62.0399692283*i+1;
B2[i] = 95.3133181077*i+1;
B3[i] = 14.5052127821*i+1;
B4[i] = 14.9891892061*i+1;
B5[i] = 25.6980077347*i+1;
B6[i] = 36.4484356333*i+1;
}
struct timeval time0,time1;
gettimeofday(&time0,NULL);
FILE *file_for_block_of_interest = fopen("./profile_in_block.txt","w");
if(file_for_block_of_interest) {
char Buf[2] = "1";
fwrite(Buf, 1, 1, file_for_block_of_interest);
fclose(file_for_block_of_interest);}
kernel_cpu(A0,A1,A2,A3,A4,B0,B1,B2,B3,B4,B5,B6,971966);
file_for_block_of_interest = fopen("./profile_in_block.txt","w");
if(file_for_block_of_interest) {
char Buf[2] = "0";
fwrite(Buf, 1, 1, file_for_block_of_interest);
fclose(file_for_block_of_interest);}
gettimeofday(&time1,NULL);
double totaltime10 = (time1.tv_sec*1000000.0 + time1.tv_usec) - (time0.tv_sec*1000000.0 + time0.tv_usec);
fprintf(stderr, "CPU time: %lf msecs ",  (totaltime10)/1000.0F); 
free(A0);
free(A1);
free(A2);
free(A3);
free(A4);
free(B0);
free(B1);
free(B2);
free(B3);
free(B4);
free(B5);
free(B6);
printf("\n");return 0; }