#include <stdio.h>
#include <stdlib.h>
#include <sys/time.h>

void kernel_cpu(int *A0,int *A1,int *A2,int *A3,int *A4,int *A5,int *A6,int *A7,float *B0,float *B1,float *B2,float *B3,int N){
for(int i=0;i<N;i++){
A0[i] = A6[i];
A1[i] = A7[i];
A2[i] = A7[i]+A7[i];
A3[i] = A6[i]-A6[i]+A7[i]+A6[i];
A4[i] = A7[i];
A5[i] = A7[i]/A7[i];
B0[i] = B3[i]*B3[i]-B3[i]+B3[i];
B1[i] = B3[i]+B3[i];
B2[i] = B3[i]/B3[i]/B3[i];
}
}

int main(int argc,char **argv) {
int size=719913;
int intBytes = size*sizeof(int);
int floatBytes = size*sizeof(float);
int *A0;
A0 = (int *)malloc(intBytes);
int *A1;
A1 = (int *)malloc(intBytes);
int *A2;
A2 = (int *)malloc(intBytes);
int *A3;
A3 = (int *)malloc(intBytes);
int *A4;
A4 = (int *)malloc(intBytes);
int *A5;
A5 = (int *)malloc(intBytes);
int *A6;
A6 = (int *)malloc(intBytes);
int *A7;
A7 = (int *)malloc(intBytes);
float *B0;
B0 = (float *)malloc(floatBytes);
float *B1;
B1 = (float *)malloc(floatBytes);
float *B2;
B2 = (float *)malloc(floatBytes);
float *B3;
B3 = (float *)malloc(floatBytes);
for(int i=0;i<719913;i++){
A0[i] = 60+i+1;
A1[i] = 33+i+1;
A2[i] = 21*i+1;
A3[i] = 71*i+1;
A4[i] = 99*i+1;
A5[i] = 96*i+1;
A6[i] = 59*i+1;
A7[i] = 22*i+1;
B0[i] = 40.695296068*i+1;
B1[i] = 48.7925088737*i+1;
B2[i] = 91.1235168354+i+1;
B3[i] = 81.350411063*i+1;
}
struct timeval time0,time1;
gettimeofday(&time0,NULL);
FILE *file_for_block_of_interest = fopen("./profile_in_block.txt","w");
if(file_for_block_of_interest) {
char Buf[2] = "1";
fwrite(Buf, 1, 1, file_for_block_of_interest);
fclose(file_for_block_of_interest);}
kernel_cpu(A0,A1,A2,A3,A4,A5,A6,A7,B0,B1,B2,B3,719913);
file_for_block_of_interest = fopen("./profile_in_block.txt","w");
if(file_for_block_of_interest) {
char Buf[2] = "0";
fwrite(Buf, 1, 1, file_for_block_of_interest);
fclose(file_for_block_of_interest);}
gettimeofday(&time1,NULL);
double totaltime10 = (time1.tv_sec*1000000.0 + time1.tv_usec) - (time0.tv_sec*1000000.0 + time0.tv_usec);
fprintf(stderr, "CPU time: %lf msecs ",  (totaltime10)/1000.0F); 
free(A0);
free(A1);
free(A2);
free(A3);
free(A4);
free(A5);
free(A6);
free(A7);
free(B0);
free(B1);
free(B2);
free(B3);
printf("\n");return 0; }