#include <stdio.h>
#include <stdlib.h>
#include <sys/time.h>

void kernel_cpu(int *A0,int *A1,int *A2,int *A3,int *A4,float *B0,float *B1,float *B2,float *B3,float *B4,float *B5,float *B6,int N){
for(int i=0;i<N;i++){
A0[i] = A4[i]*A4[i]-A4[i];
A1[i] = A4[i]*A4[i]+A4[i];
A2[i] = A4[i]+A4[i]+A4[i];
A3[i] = A4[i]-A4[i];
B0[i] = B6[i];
}
}

int main(int argc,char **argv) {
int size=729793;
int intBytes = size*sizeof(int);
int floatBytes = size*sizeof(float);
int *A0;
A0 = (int *)malloc(intBytes);
int *A1;
A1 = (int *)malloc(intBytes);
int *A2;
A2 = (int *)malloc(intBytes);
int *A3;
A3 = (int *)malloc(intBytes);
int *A4;
A4 = (int *)malloc(intBytes);
float *B0;
B0 = (float *)malloc(floatBytes);
float *B1;
B1 = (float *)malloc(floatBytes);
float *B2;
B2 = (float *)malloc(floatBytes);
float *B3;
B3 = (float *)malloc(floatBytes);
float *B4;
B4 = (float *)malloc(floatBytes);
float *B5;
B5 = (float *)malloc(floatBytes);
float *B6;
B6 = (float *)malloc(floatBytes);
for(int i=0;i<729793;i++){
A0[i] = 91+i+1;
A1[i] = 54+i+1;
A2[i] = 37*i+1;
A3[i] = 1*i+1;
A4[i] = 88*i+1;
B0[i] = 33.5102381832+i+1;
B1[i] = 94.1674265008*i+1;
B2[i] = 74.6261640158+i+1;
B3[i] = 50.7858329496*i+1;
B4[i] = 74.8318454264+i+1;
B5[i] = 24.1018944479*i+1;
B6[i] = 26.5143770723+i+1;
}
struct timeval time0,time1;
gettimeofday(&time0,NULL);
FILE *file_for_block_of_interest = fopen("./profile_in_block.txt","w");
if(file_for_block_of_interest) {
char Buf[2] = "1";
fwrite(Buf, 1, 1, file_for_block_of_interest);
fclose(file_for_block_of_interest);}
kernel_cpu(A0,A1,A2,A3,A4,B0,B1,B2,B3,B4,B5,B6,729793);
file_for_block_of_interest = fopen("./profile_in_block.txt","w");
if(file_for_block_of_interest) {
char Buf[2] = "0";
fwrite(Buf, 1, 1, file_for_block_of_interest);
fclose(file_for_block_of_interest);}
gettimeofday(&time1,NULL);
double totaltime10 = (time1.tv_sec*1000000.0 + time1.tv_usec) - (time0.tv_sec*1000000.0 + time0.tv_usec);
fprintf(stderr, "CPU time: %lf msecs ",  (totaltime10)/1000.0F); 
free(A0);
free(A1);
free(A2);
free(A3);
free(A4);
free(B0);
free(B1);
free(B2);
free(B3);
free(B4);
free(B5);
free(B6);
printf("\n");return 0; }